
#include "TNR_COLLECTION.hxx"



///////////////////////////////////////////////
//    TNR_IntArray  class                   //
///////////////////////////////////////////////
TNR_IntArray
  ::TNR_IntArray(){
  _size = _max_size = 0; 
  _element =NULL;
}

TNR_IntArray
  ::TNR_IntArray(const  TNR_IntArray& x){
  _size = _max_size = 0;
  _element =NULL;
  initialize(x._size);
  _size = x._size;

  int i;
  for(i = 0 ; i < _size;i++)  _element[i] = x._element[i];
}    

TNR_IntArray
  ::~TNR_IntArray(){
  clear(); 
}
void  TNR_IntArray  
  ::index_check(int index){
  assert((0 <= index) && (index < _size));
}

void  TNR_IntArray 
  ::clear(){
  _size = _max_size = 0;
  if (_element != NULL)
    delete[] _element; 
  _element = NULL;
}

int  TNR_IntArray
  ::initialize(int n){
  assert(n >= 0);
  clear();
  if (n == 0 ) return 0;
  return element_grow(n);
}

int TNR_IntArray
  ::element_grow(int grow_size){
 assert(_size <= _max_size);//_size > _max_size // 
 assert(grow_size > 0);      

 if (_size < _max_size) return 0;
 int max_size = _max_size + grow_size;
 assert(grow_size <= max_size); //over flow // 
 int* new_element;
 new_element  = new int[max_size];
#if 0
 try  { new_element  = new int[max_size];} 
 catch (...){
   cerr<<"Memory nothing - TNR_IntArray::element_grow()"<<endl; 
   return -1; 
 }
#endif
 int i;
 for(i = 0; i < _size;i++) new_element[i] = _element[i];
 delete [] _element;
 _max_size =  max_size;
 _element = new_element;
 return 0;
}

int  TNR_IntArray
  ::push_back(int element){
  const int grow_size = 10;
  if (_size == _max_size) 
    if(element_grow(grow_size)) return -1; 
  _element[_size] = element;  
  _size += 1;
  return 0;
}

void  TNR_IntArray 
  ::pop_back(){
  assert(0 < _size);
  _size -= 1;
}

int  TNR_IntArray
::insertAfter(int index,int element)
{
  assert(index >= 0 && index < _size );


  if (_max_size == _size){
    if(this->element_grow (_max_size + 10)){
      return -1;
    }
  }

 int* newItems = new int[_max_size];
  int i;
  for (i = 0; i <= index; i++)
    newItems[i] = _element[i];

  newItems[index+1] = element;
  _size++;

  for (i = index+2 ; i < _size; i++)
    newItems[i] = _element[i-1];

  delete[] _element;
  _element = newItems;

  return 0;
}

int   TNR_IntArray
::uniqe_add(int  element)
{
  int i;
  for(i = 0; i < _size;i++)
    if (element == _element[i])
      return i;
  this->push_back(element);
  return -1;
}


  

int  TNR_IntArray
  ::sort(int  start_index, int  end_index){
  index_check(start_index);
  index_check(end_index);
  int i,j,temp;
  for( i= start_index;i<end_index;i++){
    for(j=i;j>=0;j--){
      if(_element[j] > _element[j+1]){
        temp = _element[j];
        _element[j] = _element[j+1];
        _element[j+1] =  temp;
      }else{ 
        break;
      }
    }
  }
  return 0;
}

int  TNR_IntArray 
  ::reverse()
{
  if (_size == 0 ) return 0;
  int nMove = _size / 2;
  int count = 0;  
  int temp;
  int i;
  for(i = 0;i<_size;i++){
    temp = _element[i];
    _element[i] = _element[_size-1-i];
    _element[_size-1-i] =  temp;
    count +=  1;
    if ( count == nMove) break;
  }
  return 0;

} 

int   TNR_IntArray 
  ::remove(int index){
  index_check(index);
  assert(0<_size);
  int i;
  for(i = index; i < _size;i++)
   _element[i]  = _element[i+1];
  _size  -= 1;
  return 0;
}

int  TNR_IntArray
  ::removeEqual()
{
  //this function is bad algo 
  assert(0<_size);
  sort(0,_size-1);
  int* rm_flg = new int[_size]; 
  int temp = _element[0];
  int i;
  for(i = 0; i<_size;i++) rm_flg[i] = 0;  
  for(i = 1; i<_size;i++){
    if(temp == _element[i])
      rm_flg[i] = 1;
    else
      temp = _element[i];
  }

  int rm_count=0;
  int size = _size; 
  for(i = 0; i < size;i++){ 
    if(rm_flg[i] == 1){  
      remove(i-rm_count);
      rm_count += 1;
    }
  }
     
  delete [] rm_flg;
  return 0;
} 

int  TNR_IntArray
  ::find(int start_index,int end_index,int element,int* index)
{   
// return -1 (nothing)//  
// return index //  
  index_check(start_index);index_check(end_index);
  *index = 0;
  int i;
  for(i = start_index; i<=end_index;i++){
    if (element == _element[i]){
      *index = i;
      return 0;
    } 
  }
  return -1;
}

bool  TNR_IntArray
  ::find(int element)
{   
// return -1 (nothing)//  
// return index //  
  int i;
  for(i = 0; i < _size;i++){
    if (element == _element[i]){
      return true;
    } 
  }
  return false;
}

int  TNR_IntArray
  ::min_max(int* minp,int* maxp)
{
  assert(_size > 0);
  *minp = _element[0];
  *maxp = _element[0];
  int i;
  for(i = 0; i < _size;i++){
    if(*minp > _element[i])
      *minp = _element[i];
    if(*maxp < _element[i])
      *maxp = _element[i];
   }
  return 0;
}

void  TNR_IntArray
  ::print(){
#if 0
  fprintf(std,"size=%d\n",_size);
  fprintf(std,"max_size=%d\n",_max_size);
  int count = 0;
  if (_element == NULL){
     fprintf(std,"elem[]= NULL\n");
  }else{
    int i;
    for (i = 0; i < _size;i++){
      fprintf(std,"max_size=%d\n",_max_size);
      cout<<"elem[";cout.width(4);cout<<i<<"]=";
      cout.width(7); cout<<_element[i]<<"  "; 
      count++;
      if (count == 4){
        cout<<endl;
        count = 0;
      }
    }
    cout<<endl;
  }
#endif
}

int&  TNR_IntArray   
  ::operator[](int  index){
  index_check(index);
  return _element[index];
}                   

TNR_IntArray&  TNR_IntArray 
  ::operator=(const TNR_IntArray& x){
  if (&x != this) {
    _element =NULL;
    initialize(x._size);
    _size = x._size;
    int i;
    for(i = 0 ; i < _size;i++)  _element[i] = x._element[i];
  }
  return (*this); 
} 
 
///////////////////////////////////////////////
//    TNR_DoubleArray  class                   //
///////////////////////////////////////////////
TNR_DoubleArray
  ::TNR_DoubleArray(){
  _size = _max_size = 0;  
  _element =NULL;
}

TNR_DoubleArray
  ::TNR_DoubleArray(const  TNR_DoubleArray& x){
  _size = _max_size = 0;                                                         
  _element =NULL; 
  initialize(x._size);
  _size = x._size;
  int i;
  for(i = 0 ; i < _size;i++)  _element[i] = x._element[i];
}    

TNR_DoubleArray
  ::~TNR_DoubleArray(){
  this->clear(); 
}

void  TNR_DoubleArray  
  ::index_check(int index){
  assert((0 <= index) && (index < _size));
}

void  TNR_DoubleArray 
  ::clear(){
  _size = _max_size = 0;
  if (_element != NULL)
    delete[] _element; 
  _element = NULL;
}

int  TNR_DoubleArray
  ::initialize(int n){
  assert(n >= 0);
  clear();
  if (n == 0 ) return 0;
  return element_grow(n);
}

int TNR_DoubleArray
  ::element_grow(int grow_size){
 assert(grow_size > 0); 
 assert(_size <= _max_size); 
 if (_size < _max_size) return 0;

 int max_size = _max_size + grow_size;

 assert(grow_size <= max_size); //over flow // 
 double* new_element  = new double[max_size];
 if (new_element == NULL){ 
   fprintf(stderr,"Memory nothing - TNR_DoubleArray::element_grow()\n");
   return -1;
 }
 int i; 
 for(i = 0; i < _size;i++) new_element[i] = _element[i];
 delete [] _element;
 _max_size =  max_size;
 _element = new_element;
 return 0;
}

int  TNR_DoubleArray
  ::push_back(double element){
  const int grow_size = 10;
  if (_size == _max_size) 
    if(element_grow(grow_size)) return -1; 
  _element[_size] = element;  
  _size += 1;
  return 0;
}

void  TNR_DoubleArray 
  ::pop_back(){
  assert(0 < _size);_size -= 1;
}

int  TNR_DoubleArray
  ::sort(int  start_index, int  end_index){
  index_check(start_index);
  index_check(end_index);
  int i,j;
  double temp;
  for( i= start_index;i<end_index;i++){
    for(j=i;j>=0;j--){
      if(_element[j] > _element[j+1]){
        temp = _element[j];
        _element[j] = _element[j+1];
        _element[j+1] =  temp;
      }else{ 
        break;
      }
    }
  }
  return 0;
}

int  TNR_DoubleArray
  ::reverse(){
  if (_size == 0 ) return 0;
  int nMove = _size / 2;
  int count = 0;  
  double temp;
  for(int  i=0;i<_size;i++){
    temp = _element[i];
    _element[i] = _element[_size-1-i];
    _element[_size-1-i] =  temp;
    count +=  1;
    if ( count == nMove) break;
  }
  return 0;
}

int   TNR_DoubleArray 
  :: remove(int index){
  index_check(index);
  assert(0<_size);
  int i;
  for(i= index ; i < _size;i++)
   _element[i]  = _element[i+1];
  _size  -= 1;
  return 0;
}

int  TNR_DoubleArray
  ::removeEqual()
{
  //this function is bad algo 
  assert(0<_size);
  sort(0,_size-1);
  int*  rm_flg = new int[_size]; 
  double temp = _element[0];
  int i;
  for(i=0; i<_size;i++) rm_flg[i] = 0;  
  for(i=1; i<_size;i++){
    if(temp == _element[i])
      rm_flg[i] = 1;
    else
      temp = _element[i];
  }

  int rm_count=0;
  int size = _size; 
  for(i=0; i<size;i++){ 
    if(rm_flg[i] == 1){  
      remove(i-rm_count);
      rm_count += 1;
    }
  }
     
  delete  rm_flg;
  return 0;
} 

int  TNR_DoubleArray
  :: find(int start_index,int end_index,double element,int* index)
{   
// return -1 (nothing)//  
// return index //  
  index_check(start_index);index_check(end_index);
  *index = 0;
  for(int i=start_index; i<=end_index;i++){
    if (element == _element[i]){
      *index = i; 
      return 0;
    } 
  }
  return -1;
}

int  TNR_DoubleArray
  ::min_max(double* minp,double* maxp)
{
  assert(_size > 0);
  *minp = _element[0];
  *maxp = _element[0];
  int i;
  for(i= 1; i < _size;i++){
    if(*minp > _element[i])
      *minp = _element[i];
    if(*maxp < _element[i])
      *maxp = _element[i];
  }
  return 0;
}

int  TNR_DoubleArray
  ::normalize()
{
  double  minp,maxp;
  min_max(&minp,&maxp);
  int i;
  for(i= 0; i < _size;i++){                                                 
    _element[i] = (_element[i] - minp)  / (maxp - minp);
  }
  return 0;
}

void  TNR_DoubleArray
  ::print(){
#if 0
  cout<<"size="<<_size<<endl;
  cout<<"max_size="<<_max_size<<endl;
  int count = 0;
  cout.setf(ios::scientific,ios::floatfield);
  if (_element == NULL){
     cout<<"elem[]= NULL"<<endl;
  }else{
    for (int i = 0; i < _size;i++){
      cout<<"elem[";cout.width(4);cout<<i<<"]=";
      cout<<_element[i]<<"  "; 
      count++;
      if (count == 2){
        cout<<endl;
        count = 0;
      }
    }
    cout<<endl;
  }
#endif
}

double&  TNR_DoubleArray   
  ::operator[](int  index){
  index_check(index);
  return _element[index];
}                   

TNR_DoubleArray&  TNR_DoubleArray 
  ::operator=(const TNR_DoubleArray& x){
  if (&x != this) {
    _element =NULL;
    clear();
    initialize(x._size);
    _size = x._size;
    for(int i = 0 ; i < _size;i++)  _element[i] = x._element[i];
  }
  return (*this); 
} 


///////////////////////////////////////////////
//    TNR_StringArray  class                //
///////////////////////////////////////////////
TNR_StringArray
  ::TNR_StringArray(){
  _size = 0;
  _max_size = 0;
  _element =NULL;
}

TNR_StringArray 
  ::~TNR_StringArray()
{
  clear();
}

void  TNR_StringArray  
  ::index_check(int index){
  assert((0 <= index) && (index < _size));
}
void  TNR_StringArray 
  ::clear()
{
  _size = _max_size = 0;
  if (_element != NULL)
    delete[] _element; 
  _element = NULL;
}

int  TNR_StringArray  
  ::element_grow(int grow_size)
{
 assert(grow_size > 0); 
 assert(_size <= _max_size); 
 if (_size < _max_size) return 0;

 int max_size = _max_size + grow_size;
 assert(grow_size <= max_size); //over flow // 
 char** new_element  = new char*[max_size];
 if (new_element == NULL){
    fprintf(stderr,"Memory nothing - TNR_StringArray::element_grow()\n");
    return -1;
 }
 for(int i= 0; i < _size;i++) new_element[i] = _element[i];
 delete [] _element;
 _max_size =  max_size;
 _element = new_element;
 return 0;
}

int  TNR_StringArray
  ::initialize(int n){
  assert(n >= 0);
  clear();
  if (n == 0 ) return 0;
  return element_grow(n);
}

int  TNR_StringArray
  ::push_back(char* element){
  const int grow_size = 10;
  if (_size == _max_size) 
    if(element_grow(grow_size)) return -1; 
  _element[_size] = element;  
  _size += 1;
  return 0;
}

void  TNR_StringArray
  ::pop_back(){
  assert(0 < _size);
  _size -= 1;
}

int  TNR_StringArray  
  ::length(int  index) {
  index_check(index);
  return int(strlen(_element[index]));
}

void  TNR_StringArray
  ::print(){
#if 0
  cout<<"size="<<_size<<endl;
  cout<<"max_size="<<_max_size<<endl;
  if (_element == NULL){
     cout<<"element[]= NULL"<<endl;
  }else{ 
    for (int i = 0; i < _size;i++)
      cout<<"element["<<i<<"]="<<_element[i]<<endl;
  }
#endif
}
char*  TNR_StringArray   
  ::operator[](int  index){
  index_check(index);
  return _element[index];
}                   

