#ifndef __TNR_COLLECTION_H
#define __TNR_COLLECTION_H

#include <stdio.h>
#include <assert.h>
#include <string.h>
///////////////////////////////////////////////////////////////////
//         TNR_IntArray  class                                  //
////////////////////////////////////////////////////////////////////
class TNR_IntArray{
private:
  int   _size;
  int   _max_size;
  int*  _element; 
public:
TNR_IntArray();
TNR_IntArray(const  TNR_IntArray& x);
~TNR_IntArray();
void  index_check(int index); 
void  clear();
int   size(){ return _size;}
int   initialize (int n); 
int   element_grow(int grow_size); 
int   push_back(int element);
void  pop_back();
int   uniqe_add(int element);
int   sort(int  start_index, int  end_index);
int   reverse();
int   remove(int index);
int   removeEqual();
int   find(int start_index,int end_index,int element,int* index);
bool  find(int element);
int   insertAfter(int index,int element);
int   min_max(int* minp,int* maxp);
void  print();
int&  operator[](int  index);
TNR_IntArray&   operator=(const TNR_IntArray& x); 
};

///////////////////////////////////////////////////////////////////
//         TNR_DoubleArray  class                                  //
////////////////////////////////////////////////////////////////////
class TNR_DoubleArray{
private:
  int   _size;
  int   _max_size;
  double*  _element; 
public:
TNR_DoubleArray();
TNR_DoubleArray(const  TNR_DoubleArray& x);
~TNR_DoubleArray();
void  index_check(int index); 
void  clear();
int   size(){ return _size;}
int   initialize (int n); 
int   element_grow(int grow_size); 
int   push_back(double element);
void  pop_back();
int   sort(int  start_index, int  end_index);
int   reverse();
int   remove(int index);
int   removeEqual();
int   find(int start_index,int end_index,double element,int* index);
int   min_max(double* minp,double* maxp);
int   normalize(); 
void  print();
double&  operator[](int  index);
TNR_DoubleArray&   operator=(const TNR_DoubleArray& x); 
};

///////////////////////////////////////////////////////////////////
//         TNR_StringArray  class                               //
////////////////////////////////////////////////////////////////////
class TNR_StringArray{
private:
  int     _size;
  int     _max_size;
  char**  _element; 
public:
TNR_StringArray();
~TNR_StringArray();
void  index_check(int index); 
void  clear();
int   size(){ return _size;}
int   element_grow(int grow_size); 
int   initialize (int n); 
int   push_back(char* element);
void  pop_back();
int   length(int  index) ;
char* operator[](int  index);
void  print();
};



#endif
