#ifndef __TNR_QUAD_MESH_HXX
#define __TNR_QUAD_MESH_HXX

#include <string>
#include "TNR_VECTOR.hxx"
#include "TNR_MESH.hxx"
#include "TNR_INI.hxx"
#include <map>
#include <vector>
//#include <windows.h>


class TNR_QUAD {
  int v[4];
public:
  int& operator[](int i){return v[i];}
};

class TNR_QUAD_MESH:public TNR_MESH{
   vector<TNR_POINT> _points;
   vector<TNR_QUAD>  _quads;
public:
   vector<int>       _edgePoints[4];

public:
  TNR_QUAD_MESH(){}
  TNR_QUAD_MESH(string& name){_name = name;}
  ~TNR_QUAD_MESH(){}
  string getType(){return "QUAD";}
  void initilize (int vertSize,int faceSize)
  {_points.resize(vertSize);_quads.resize(faceSize);}
  int getNumPoints(){return _points.size();}
  int getNumMeshes(){return _quads.size();}
  void  setPoint(int i,TNR_POINT p) {_points[i] = p;}
  void  setMesh(int i,TNR_QUAD q) {_quads[i] = q;}
  TNR_POINT  getPoint(int i) {return _points[i];}
  TNR_QUAD   getQuad(int i) {return _quads[i];}
  bool isConvex(int i);
  //  create quad mesh.this funciton include smooth boundary points and smooth internal points.
  void createMesh(TNR_SECTION* surface,
				  TNR_COMAMND* commands);
private:
  void projectionToBoundary(TNR_SECTION* surface);
  void smoothInternalPoints();
};






#endif