#ifndef __TNR_SOLID_HXX
#define __TNR_SOLID_HXX

#include <string>
#include <vector>
#include "TNR_VECTOR.hxx"

using namespace std;



class TNR_SOLID{
protected:
public:
  TNR_SOLID(){}
  ~TNR_SOLID(){}
  virtual  string getSolidType() = 0;
  virtual  TNR_POINT getPosition(double u,double v,double t) = 0;
  virtual  double getUMaximumSideLength() = 0;
  virtual  double getVMaximumSideLength() = 0;
  virtual  double getTMaximumSideLength() = 0;
};


class TNR_CUBE8:private TNR_SOLID{
protected:
  TNR_POINT   _p[8]; 
public:
  TNR_CUBE8(TNR_POINT  p[8]);
   string getSolidType(){return "cube8";}
  TNR_POINT getPosition(double pu,double pv,double pt);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
  double getTMaximumSideLength();

};

class TNR_CUBE20:private TNR_SOLID{
protected:
  TNR_POINT   _p[20]; 
public:
  TNR_CUBE20(TNR_POINT  p[20]);
   string getSolidType(){return "cube20";}
  TNR_POINT getPosition(double u,double v,double t);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
  double getTMaximumSideLength();

};


#endif
