#ifndef __TNR_SURFACE_HXX
#define __TNR_SURFACE_HXX

#include <string>
#include <vector>
using namespace std;
#include "TNR_VECTOR.hxx"

using namespace std;


class TNR_SURFACE {
protected:
public:
	TNR_SURFACE(){}
  ~TNR_SURFACE(){}
  virtual  string getSurfaceType() = 0;
  virtual  TNR_POINT getPosition(double u,double v) = 0;
  virtual  double getUMaximumSideLength() = 0;
  virtual  double getVMaximumSideLength() = 0;
};

class TNR_BILINEAR_SURFACE:private TNR_SURFACE{
protected:
  TNR_POINT   _p[4]; 
public:
  TNR_BILINEAR_SURFACE(TNR_POINT  p[4]);
   string getSurfaceType(){return "bilinearSurface";}
  TNR_POINT getPosition(double u,double v);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
};

class TNR_QUADRIC_SURFACE:private TNR_SURFACE{
protected:
  TNR_POINT   _p[8]; 
public:
  TNR_QUADRIC_SURFACE(TNR_POINT  p[8]);
   string getSurfaceType(){return "quadricSurface";}
  TNR_POINT getPosition(double u,double v);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
};

class TNR_CUBIC_SURFACE:private TNR_SURFACE{
protected:
  TNR_POINT   _p[12]; 
public:
  TNR_CUBIC_SURFACE(TNR_POINT  p[12]);
   string getSurfaceType(){return "cubicSurface";}
  TNR_POINT getPosition(double u,double v);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
};

class TNR_CIRCLE_SURFACE:private TNR_SURFACE{
protected:
  double       _r;
  TNR_POINT    _center;
public:
  TNR_CIRCLE_SURFACE(TNR_POINT center,double radius);
  string getSurfaceType(){return "circleSurface";}
  TNR_POINT getPosition(double u,double v);
  double getUMaximumSideLength();
  double getVMaximumSideLength();
};


class TNR_ELLIPSE_SURFACE:private TNR_SURFACE{
protected:
  double       _a;//major axis radius;
  double       _b;//minor axis radius;
  TNR_POINT    _center;
public:
  TNR_ELLIPSE_SURFACE(TNR_POINT center,double majorAxisRadius,double minorAxisRadius);
  string  getSurfaceType(){return "ellipseSurface";}
  TNR_POINT getPosition(double u,double v);
  double getUMaximumSideLength();
  double getVMaximumSideLength();

};


#endif
