#include "TNR_TRANSFORM.hxx"
#include "TNR_VECTOR.hxx"
#include <stdlib.h>
#include <stdio.h>
#include <float.h>

void TNR_section_transration(TNR_SECTION* s,
							 string& type,// move, rotate,scale
							 string& centerType,//only rotate. origin or center of shape.
							 TNR_POINT centerofRotate,
							 TNR_POINT transValue)
{


  ////////
  //face//
  ////////
  if(s->getName() == "face"){
    int numPoins = s->getNumData();
	if(numPoins == 0){ 
		return;
	}
    TNR_POINT* p= new TNR_POINT[numPoins];
	TNR_POINT hight(-DBL_MAX,-DBL_MAX,-DBL_MAX);
    TNR_POINT low(DBL_MAX,DBL_MAX,DBL_MAX);

    for(int i = 0; i < numPoins ; i++){
      string data = s->getData(i);
      sscanf(data.c_str(),"%lf %lf %lf", &(p[i][0]),&(p[i][1]),&(p[i][2]));
	  hight.upper(p[i]);
	  low.lower(p[i]);
    }

	//get graviry
	TNR_POINT center = 0.5 * (hight - low);
	if(type == "move"){
      for(int i = 0; i < numPoins; i++){
		  p[i].move(center,transValue);
	  }
    }

	if(type == "scale"){
      for(int i = 0; i < numPoins; i++){
		  p[i].scale(center,transValue);
	  }
    }


	if(type == "rotate"){
  	  if(centerType == "origin"){
	    center[0] = 0.0;center[1] = 0.0;center[2] = 0.0;
	  }
  	  if(centerType == "centerOfRotate"){
	    center =centerofRotate;
	  }


      for(int i = 0; i < numPoins; i++){
	    p[i] = p[i].rotateByXAxis(center,(transValue[0] * M_PI) / 180);
		p[i] = p[i].rotateByYAxis(center,(transValue[1] * M_PI) / 180);
		p[i] = p[i].rotateByZAxis(center,(transValue[2] * M_PI) / 180);
	  }
    }

   //replace       
    for(int i = 0; i < numPoins ; i++){
      string data = s->getData(i);
	  char buf[1024];
      sprintf(buf,"%f %f %f", p[i][0],p[i][1],p[i][2]);
      s->setData(i,string(buf));
    } 
  }//end face


}




 
